/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*                                                               */
/*   File name : [ProjectName].c                                 */
/*                                                               */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*****************************************************************/
#include "fxlib.h"
#include "MonochromeLib.h"
#include "math.h"

//****************************************************************************
//  AddIn_main (Sample program main function)
//
//  param   :   isAppli   : 1 = This application is launched by MAIN MENU.
//                        : 0 = This application is launched by a strip in eACT application.
//
//              OptionNum : Strip number (0~3)
//                         (This parameter is only used when isAppli parameter is 0.)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int AddIn_main(int isAppli, unsigned short OptionNum)
{
	double PI = 3.1415926535897932;
	double r = 0, angleCam = 0, camX = 2, camY = 4, distRayon = 0, angleRayon = 0, distMur = 0;
	int murX, murY, ray = 0;
	unsigned int key;

	int map[7] [21] =
	{{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1},
	{1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1},
	{1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
	{1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1},	
	{1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}};

	do{
	ML_clear_vram();

	//Calculs de deplacements
	camX = camX+r*(cos(angleCam));
	camY = camY+r*(sin(angleCam));
	r = 0;
	
	//Rayons de detection
	ray = 0;
	for(angleRayon = angleCam-(1.0/6*PI); angleRayon<angleCam+(1.0/6*PI); angleRayon = angleRayon+0.0082)
	{
		ray++;
		for(distRayon = 0; distRayon<=20; distRayon++)
		{
			murX = (int) (distRayon*cos(angleRayon)+camX);
			murY = (int) (distRayon*sin(angleRayon)+camY);

			if(map[murY] [murX] == 1)
			{
				distMur = sqrt(pow((distRayon*cos(angleRayon)+camX)-camX, 2)+pow(	(distRayon*sin(angleRayon)+camY)-camY, 2));
				ML_line(ray, (int) (((31/distMur)*2)+31), ray, (int) (((-31/distMur)*2)+31), ML_BLACK);
				break;
			}
		}
	}

	ML_clear_screen();
	ML_display_vram();

	GetKey(&key);

	//Commandes
	if(key == KEY_CTRL_UP && map[(int) (1*sin(angleCam)+camY)] [(int) (1*cos(angleCam)+camX)] != 1)
	{
		r++;
	}
	if(key == KEY_CTRL_DOWN && map[(int) (-1*sin(angleCam)+camY)] [(int) (-1*cos(angleCam)+camX)] != 1)
	{
		r--;
	}
	if(key == KEY_CTRL_LEFT)
	{
		angleCam = angleCam-(1.0/12*PI);
	}
	if(key == KEY_CTRL_RIGHT)
	{
		angleCam = angleCam+(1.0/12*PI);
	}

	}while (key != KEY_CTRL_EXIT);
	
	return 1;
}




//****************************************************************************
//**************                                              ****************
//**************                 Notice!                      ****************
//**************                                              ****************
//**************  Please do not change the following source.  ****************
//**************                                              ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

